--[[
]]--

local comboPlayed = false;
--Stores the current amount of combo points, this should start at 0			
local curComboPoint = 0	      	
local cosmosAvailable = false;

CombatSoundConfig = { useCombo = false, useComboFull = true, useDodge = false, useParry = false, useCrit = false };

function CombatSoundMsg(msg)
	if( DEFAULT_CHAT_FRAME ) then 
		DEFAULT_CHAT_FRAME:AddMessage(msg);
	end
end

function CombatSound_OnLoad()
	this:RegisterEvent("UNIT_COMBAT");
	if ( Cosmos_RegisterConfiguration ) then
		cosmosAvailable = true;
		Cosmos_RegisterConfiguration(
			"COS_CS",
			"SECTION",
			"CombatSound",
			"Options for audible notifys during combat."
		);
		Cosmos_RegisterConfiguration(
			"COS_CS_SEPARATOR",
			"SEPARATOR",
			"CombatSound",
			"Options for audible notifys during combat."		
		);
		Cosmos_RegisterConfiguration(
			"COS_CS_COMBO",
			"CHECKBOX",
			"Enable notify for combo points.",
			"By enabling this a sound will be played each time you gain a combo point, used by rogues and druids.",
			CombatSoundUseCombo,
			CombatSoundConfig.useCombo
		);
		Cosmos_RegisterConfiguration(
			"COS_CS_COMBOFULL",
			"CHECKBOX",
			"Enable notify for 5 combo points.",
			"By enabling this a sound will be played each time you gain 5 combo points, used by rogues and druids.",
			CombatSoundUseComboFull,
			CombatSoundConfig.useComboFull
		);
		Cosmos_RegisterConfiguration(
			"COS_CS_DODGE",
			"CHECKBOX",
			"Enable notify for dodge.",
			"By enabling this a sound will be played each time you dodge an attack.",
			CombatSoundUseDodge,
			CombatSoundConfig.useDodge
		);
		Cosmos_RegisterConfiguration(
			"COS_CS_PARRY",
			"CHECKBOX",
			"Enable notify for parry.",
			"By enabling this a sound will be played each time you parry an attack.",
			CombatSoundUseParry,
			CombatSoundConfig.useParry
		);
		Cosmos_RegisterConfiguration(
			"COS_CS_CRIT",
			"CHECKBOX",
			"Enable notify for critical hit.",
			"By enabling this a sound will be played each time you critically hit your target.",
			CombatSoundUseCrit,
			CombatSoundConfig.useCrit
		);
		local comlist = { "/combatsound", "/coms" };
		local desc = COMBATSOUND_COSMOS_SLASH_DESC;
		local id = "COMBATSOUND";
		local func = CombatSoundCMD
		Cosmos_RegisterChatCommand ( id, comlist, func, desc, CSM_CHAINNONE );
	else
		RegisterForSave("CombatSoundConfig");
		SLASH_CombatSOUND1 = "/cs";
		SLASH_CombatSOUND2 = "/combatsound";
		SlashCmdList["CombatSOUND"] = function(msg)
			CombatSoundCMD(msg);
		end
	end
end

function CombatSound_OnEvent()
	if( event == "UNIT_COMBAT") then

		if (CombatSoundConfig.useCombo) then	

			--If the current amount of combo points is more than the original
			--combo sound should be played and the current amt of combo points increased
			if(GetComboPoints("Player") > curComboPoint) then
			
				curComboPoint = curComboPoint + 1
				
				if(curComboPoint < 5) then
					
					PlaySoundFile("Interface\\AddOns\\CombatSound\\Sounds\\combo"..curComboPoint..".mp3");
				
				end
		
			--If there are less combo points than the amount stored then resets the
			--current combo points back to 0
			elseif(GetComboPoints("Player") < curComboPoint) then

				curComboPoint = 0		

			end
			
		end	
		
		if (CombatSoundConfig.useComboFull) then	

			if( GetComboPoints("Player") == 5 and not comboPlayed) then

				PlaySoundFile("Interface\\AddOns\\CombatSound\\Sounds\\comboFull.wav");
				comboPlayed = true;

			elseif( GetComboPoints("Player") ~= 5 and comboPlayed) then

				comboPlayed = false;

			end

		end
      				      	
		
		if (CombatSoundConfig.useDodge) then

			if (arg1=="player") and (arg2=="DODGE") then

				PlaySoundFile("Interface\\AddOns\\CombatSound\\Sounds\\dodge.wav");

			end

      		end		      	

		if (CombatSoundConfig.useParry) then

			if (arg1=="player") and (arg2=="PARRY") then

				PlaySoundFile("Interface\\AddOns\\CombatSound\\Sounds\\parry.wav");

			end

      		end		      	

		if (CombatSoundConfig.useCrit) then

			if (arg1=="target") and (arg3=="CRITICAL") then

				PlaySoundFile("Interface\\AddOns\\CombatSound\\Sounds\\crit.wav");

			end
      		end		      	
	end
end

function CombatSoundUseCombo(toggle)
	if(toggle == 1) then
		CombatSoundConfig.useCombo = true;
	else
		CombatSoundConfig.useCombo = false;
	end
end

function CombatSoundUseComboFull(toggle)
	if(toggle == 1) then
		CombatSoundConfig.useComboFull = true;
	else
		CombatSoundConfig.useComboFull = false;
	end
end

function CombatSoundUseDodge(toggle)
	if(toggle == 1) then
		CombatSoundConfig.useDodge = true;
	else
		CombatSoundConfig.useDodge = false;
	end
end

function CombatSoundUseParry(toggle)
	if(toggle == 1) then
		CombatSoundConfig.useParry = true;
	else
		CombatSoundConfig.useParry = false;
	end
end

function CombatSoundUseCrit(toggle)
	if(toggle == 1) then
		CombatSoundConfig.useCrit = true;
	else
		CombatSoundConfig.useCrit = false;
	end
end

function CombatSoundCMD(command)
	local cmd;
	if (not cmd) then 
		cmd = command; 
	end
	if (not cmd) then 
		cmd = ""; 
	end
	local useCombo = "Off";
	if (CombatSoundConfig.useCombo) then 
		useCombo = "On"; 
	end
	local useComboFull = "Off";
	if (CombatSoundConfig.useComboFull) then 
		useComboFull = "On"; 
	end
	local useDodge = "Off";
	if (CombatSoundConfig.useDodge) then 
		useDodge = "On"; 
	end
	local useParry = "Off";
	if (CombatSoundConfig.useParry) then 
		useParry = "On"; 
	end
	local useCrit = "Off";
	if (CombatSoundConfig.useCrit) then 
		useCrit = "On"; 
	end
	if ((cmd == "") or (cmd == "help")) then
		CombatSoundMsg("|cffffffffCombatSound v1.0");
		CombatSoundMsg("   |cffffffff/cs combo - turns combo points notify on/off|r |cff2040ff["..useCombo.."]|r");
		CombatSoundMsg("   |cffffffff/cs combofull - turns 5 combo points notify on/off|r |cff2040ff["..useComboFull.."]|r");
		CombatSoundMsg("   |cffffffff/cs dodge - turns dodge notify on/off|r |cff2040ff["..useDodge.."]|r");
		CombatSoundMsg("   |cffffffff/cs parry - turns parry notify on/off|r |cff2040ff["..useParry.."]|r");
		CombatSoundMsg("   |cffffffff/cs crit - turns critical hit notify on/off|r |cff2040ff["..useCrit.."]|r");
	end
	
	if (cmd == "combo") then
		local temp = 1;
		if (CombatSoundConfig.useCombo) then
			temp = 0;
		end
		CombatSoundUseCombo(temp)
		if ( Cosmos_RegisterConfiguration ) then
			COS_CS_COMBO_X=temp;
			Cosmos_UpdateValue("COS_CS_COMBO", CSM_CHECKONOFF, temp);
			Cosmos_SetCVar("COS_CS_COMBO_X", temp);
		end
		local useCombo = "Off";
		if (CombatSoundConfig.useCombo) then 
			useCombo = "On"; 
		end
		CombatSoundMsg("   CombatSound combo point notify turned |cff2040ff["..useCombo.."]|r");	
	end
	
	if (cmd == "combofull") then
		local temp = 1;
		if (CombatSoundConfig.useComboFull) then
			temp = 0;
		end
		CombatSoundUseComboFull(temp)
		if ( Cosmos_RegisterConfiguration ) then
			COS_CS_COMBOFULL_X=temp;
			Cosmos_UpdateValue("COS_CS_COMBOFULL", CSM_CHECKONOFF, temp);
			Cosmos_SetCVar("COS_CS_COMBOFULL_X", temp);
		end
		local useComboFull = "Off";
		if (CombatSoundConfig.useComboFull) then 
			useComboFull = "On"; 
		end
		CombatSoundMsg("   CombatSound 5 combo point notify turned |cff2040ff["..useComboFull.."]|r");	
	end

	if (cmd == "dodge") then
		local temp = 1;
		if (CombatSoundConfig.useDodge) then
			temp = 0;
		end
		CombatSoundUseDodge(temp)
		if ( Cosmos_RegisterConfiguration ) then
			COS_CS_DODGE_X=temp;
			Cosmos_UpdateValue("COS_CS_DODGE", CSM_CHECKONOFF, temp);
			Cosmos_SetCVar("COS_CS_DODGE_X", temp);
		end
		local useDodge = "Off";
		if (CombatSoundConfig.useDodge) then 
			useDodge = "On"; 
		end
		CombatSoundMsg("   CombatSound dodge notify turned |cff2040ff["..useDodge.."]|r");
	end

	if (cmd == "parry") then
		local temp = 1;
		if (CombatSoundConfig.useParry) then
			temp = 0;
		end
		CombatSoundUseParry(temp)
		if ( Cosmos_RegisterConfiguration ) then
			COS_CS_PARRY_X=temp;
			Cosmos_UpdateValue("COS_CS_PARRY", CSM_CHECKONOFF, temp);
			Cosmos_SetCVar("COS_CS_PARRY_X", temp);
		end
		local useParry = "Off";
		if (CombatSoundConfig.useParry) then 
			useParry = "On"; 
		end
		CombatSoundMsg("   CombatSound parry notify turned |cff2040ff["..useParry.."]|r");
	end

	if (cmd == "crit") then
		local temp = 1;
		if (CombatSoundConfig.useCrit) then
			temp = 0;
		end
		CombatSoundUseCrit(temp)
		if ( Cosmos_RegisterConfiguration ) then
			COS_CS_CRIT_X=temp;
			Cosmos_UpdateValue("COS_CS_CRIT", CSM_CHECKONOFF, temp);
			Cosmos_SetCVar("COS_CS_CRIT_X", temp);
		end
		local useCrit = "Off";
		if (CombatSoundConfig.useCrit) then 
			useCrit = "On"; 
		end
		CombatSoundMsg("   CombatSound critical hit notify turned |cff2040ff["..useCrit.."]|r");
	end
end
